#! /bin/csh
#  pfort is a csh script to verify the portability of a Fortran program
#  using ISTPF.
#    (via the combined tool fragment ISTLA = ISTLX/ISTYP/ISTSA and then ISTPF)
#
#
#  Invocation:
#
#  pfort Fortran_source_file
#
#  Check command line validity.
if ( $#argv == '0' ) then
TOOLPACKPATH/toolpack1.2/util/echoerr \
Invocation:
TOOLPACKPATH/toolpack1.2/util/echoerr ""
TOOLPACKPATH/toolpack1.2/util/echoerr \
pfort Fortran_source_file
TOOLPACKPATH/toolpack1.2/util/echoerr ""
TOOLPACKPATH/toolpack1.2/util/echoerr \
Error/Warning messages sent to standard output and may be redirected to a file.
TOOLPACKPATH/toolpack1.2/util/echoerr ""
   exit
endif
#  Check that Fortran_source_file exists.
if ( -e $1 == 0 ) then
TOOLPACKPATH/toolpack1.2/util/echoerr \
"'$1' does not exist."
   exit
endif
#
#  Create PFS.  If PFS already exists, exit with an advisory message.
#
if ( -e _.TOOLPACK == 0 ) then
   mkdir _.TOOLPACK
else
TOOLPACKPATH/toolpack1.2/util/echoerr \
Toolpack-created directory '"_.TOOLPACK"' exists. \
Remove with script '"discard"'.
   exit
endif
#  Make a tab-free copy of the Fortran source and use it as source.
set src = la.src$$
expand $1 > _.TOOLPACK/$src
#  Parse tree file name.
set tree = _.latree
#  Symbol table file name.
set symb = _.lasymb
#  Attribute file name.
set attrib = _.laattrib
#  Comment file name.
set cmt = _.lacmt
#  Comment index file name.
set indx = _.laindx
#  Create the interprocess file IST.CMD and append parameters for ISTLA.
TOOLPACKPATH/toolpack1.2/util/mkipf \
$src $cmt $tree $symb $indx $attrib
#
#  Invoke ISTLA.
#
TOOLPACKPATH/toolpack1.2/exec/istla.u
#
#  If tool terminated with errors, advise user to obtain listing.  Exit.
if ( `cat _.TOOLPACK/_.info` == -1 ) then
TOOLPACKPATH/toolpack1.2/util/echoerr ""
TOOLPACKPATH/toolpack1.2/util/echoerr \
'Errors detected.  Invoke script "getlst" to obtain a listing showing'
TOOLPACKPATH/toolpack1.2/util/echoerr \
statement and token numbers.
TOOLPACKPATH/toolpack1.2/util/echoerr ""
   /bin/rm -r _.TOOLPACK
   exit
endif
#  Create the interprocess file IST.CMD and append parameters for ISTPF.
TOOLPACKPATH/toolpack1.2/util/mkipf \
$tree $symb $attrib -
#
#  Invoke ISTPF.
#
TOOLPACKPATH/toolpack1.2/exec/istpf.u
#
/bin/rm -r _.TOOLPACK
#
